=== modified file 'bzrtools.py'
--- bzrtools.py	2005-09-26 15:00:54 +0000
+++ bzrtools.py	2005-09-27 13:18:25 +0000
@@ -173,7 +173,9 @@
         proc.stdout.read()
         proc.stdout.close()
     proc.wait()
-    if proc.returncode == 23:
+    if proc.returncode == 12:
+        raise RsyncStreamIO()
+    elif proc.returncode == 23:
         raise RsyncNoFile(source)
     elif proc.returncode != 0:
         raise RsyncUnknownStatus(proc.returncode)
@@ -196,7 +198,9 @@
         proc.stderr.read()
         proc.stderr.close()
     proc.wait()
-    if proc.returncode == 23:
+    if proc.returncode == 12:
+        raise RsyncStreamIO()
+    elif proc.returncode == 23:
         raise RsyncNoFile(source)
     elif proc.returncode != 0:
         raise RsyncUnknownStatus(proc.returncode)
@@ -215,6 +219,10 @@
     def __init__(self, path):
         Exception.__init__(self, "No such file %s" % path)
 
+class RsyncStreamIO(Exception):
+    def __init__(self):
+        Exception.__init__(self, "Error in rsync protocol data stream.")
+
 def get_revision_history(location):
     tempdir = tempfile.mkdtemp('push')
     try:
@@ -271,6 +279,10 @@
                 raise bzrlib.errors.BzrCommandError("Remote location is not a"
                                                     " bzr branch (or empty"
                                                     " directory)")
+        except RsyncStreamIO:
+            raise bzrlib.errors.BzrCommandError("Rsync could not use the"
+                " specified location.  Please ensure that"
+                ' "%s" is of the form "machine:/path".' % push_location)
     print "Pushing to %s" % push_location
     rsync(cur_branch.base+'/', push_location, ssh=True, excludes=non_source)
 

